import { AxiosInstance, AxiosResponse } from "axios";

export type RequestData<PARAMS, BODY> = PARAMS extends void
  ? BODY extends void
    ? {}
    : { body: BODY }
  : BODY extends void
  ? { params: PARAMS }
  : { params: PARAMS; body: BODY };

export type RequestDefinition<PARAMS = void, BODY = void, RESPONSE = void> = (
  http: AxiosInstance,
  params: RequestData<PARAMS, BODY>
) => Promise<AxiosResponse<RESPONSE, any>>;
